//+------------------------------------------------------------------+
//|                                                  Cheburashka.mq4 |
//|                                         Copyright  2008, Kirill |
//|                                          StockProgrammer@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Kirill"
#property link      "StockProgrammer@mail.ru"

/*
BuyStopPrice -    Buy Stop ,     . 
  Stop Loss & Take Profit .Order Level-   Stop Loss & 
Take Profit.Lots_1,Lots_2   Lots_10 (   ,  ,
  ).  Buy Stop    Sell Stop c    
  Stop Loss  .   ,   .  
   Stop Loss,         
     ,        
 ,   Take Profit,   10 .

TimeFrame = 60
Magic_N = 444,    ,     ,    , 
.. 444, 445, 446, 447, ..
 
         .

:

1.       TakeProfit

*/

extern int     Magic          =  1032;
extern int     Delta          =  20;
extern int     TakeProfit     =  60;      //  BUYSTOP
extern int     TakeProfit1    =  80;      //  SELLSTOP
extern int     StopLoss       =  50;
extern bool    UseTrailOnly1  =  true;
extern int     Trail1         =  20;
extern bool    UseZeroLossStrategy = false;     //   
extern int     ZeroLossT      =  3;       //     
extern double  Lots_1         =  0.1;
extern double  Lots_2         =  0.2;
extern double  Lots_3         =  0.4;
extern double  Lots_4         =  0.8;
extern double  Lots_5         =  1.6;
extern double  Lots_6         =  3.2;
extern double  Lots_7         =  6.4;
extern double  Lots_8         = 12.8;
extern double  Lots_9         = 25.6;
extern double  Lots_10        = 51.2;

int            slip           =  3;

bool           flag           =  1;    //1 = restart flag
double         BSP            =  0.0;  //last used BuyStopPrice
bool           chk;
int            t1, t2;                 //Temporary ticket holders for the first two orders of current series
int            T;                      //Current pending order array index (0, 1, 2, 3, 4, 5, 6, 7, 8, 9)
int            tArray[10];             //Holds current series ticket numbers
   
double         LotsArray[10];          //Convenience array. Holds input parameters
double         BuyStopPrice = 0; 
int Ticket[1000];

int critical = 0;

double Point_;

string         CommentArray[7];

int init()
{
   CommentArray[0] = "Cheburashka v19.1.1";

   Point_ = Point;

   if((Digits == 3 || Digits == 5))
     {
      Point_ = 10*Point;
     }


      LotsArray[0] = Lots_1;
      LotsArray[1] = Lots_2;
      LotsArray[2] = Lots_3;
      LotsArray[3] = Lots_4;
      LotsArray[4] = Lots_5;
      LotsArray[5] = Lots_6;
      LotsArray[6] = Lots_7;
      LotsArray[7] = Lots_8;
      LotsArray[8] = Lots_9;
      LotsArray[9] = Lots_10;
   return(0);
}

int deinit()
{
    Alert("Deinit. Saving data to file \"Cheburashka_" + DoubleToStr(Magic, 0) + ".csv\". Pending orders WILL NOT be deleted.");
    if(critical == 1)
    {
      GlobalVariableSet("SEMAPHORE_CHEB_1", 0.0);    // ,   ,      
      GlobalVariableSet("SEMAPHORE_CHEB_2", 0.0);    // ,   ,      
    }  
    return(0);
}

int start()
{
   bool AllowTrades = true;
   
      
   if(AllowTrades == true)
   {

      if(flag == 1 && BSP == BuyStopPrice) BuyStopPrice = Ask + Delta*Point_;
      //no else !
      //WORK BLOCK
      { 
         if(T==0)
            CommentArray[1] = "System is working. No active lot yet.";
         else
            CommentArray[1] = "System is working. Active lot: " + DoubleToStr(LotsArray[T-1],2);
        
         if(flag==1) //  
         {
            Alert(Ask, " ", Delta, " ", DoubleToStr(Point_,5), " ", BuyStopPrice);
            t1 = OrderSend(Symbol(), OP_BUYSTOP, LotsArray[0], BuyStopPrice, slip, BuyStopPrice - StopLoss*Point_, BuyStopPrice + TakeProfit*Point_, NULL, Magic);
            if(t1 < 0)  {restart(1); return (0);}
         
            t2 = OrderSend(Symbol(), OP_SELLSTOP, LotsArray[0], BuyStopPrice - StopLoss*Point_, slip, BuyStopPrice, BuyStopPrice - StopLoss*Point_ - TakeProfit1*Point_, NULL, Magic);
            if(t2 < 0)  {restart(2); return (0);}
         
            flag = 0; BSP = BuyStopPrice;
         
         }
      
         else
         {
            if(T == 0)
            {
               chk = OrderSelect(t1, SELECT_BY_TICKET);
               if(OrderType() == OP_BUY)
               {
                  chk = OrderDelete(t2);
                  tArray[0] = t1;
                  tArray[1] = OrderSend(Symbol(), OP_SELLSTOP, LotsArray[1], BuyStopPrice - StopLoss*Point_, slip, BuyStopPrice, BuyStopPrice - StopLoss*Point_ - TakeProfit1*Point_, NULL, Magic);
                  T = 1;
                  if(tArray[1] < 0)  {restart(0); return (0);}
               
                  return (0);
               }   
         
               chk = OrderSelect(t2, SELECT_BY_TICKET);      
               if(OrderType() == OP_SELL)
               {
                  chk = OrderDelete(t1);
                  tArray[0] = t2;
                  tArray[1] = OrderSend(Symbol(), OP_BUYSTOP, LotsArray[1], BuyStopPrice, slip, BuyStopPrice - StopLoss*Point_, BuyStopPrice + TakeProfit*Point_, NULL, Magic);
                  T = 1;
                  if(tArray[1] < 0)  {restart(0); return (0);}
               
                  return(0);            
               }
            
               return (0); //none of the first two orders have been opened   
            }
            else
            {
               if(!OrderSelect(tArray[T-1], SELECT_BY_TICKET)) Alert("???");
               if(OrderCloseTime()!=0)
               {           
                  if(OrderProfit() >= 0) //Profit or Trailing-stop exit
                  {
                     //the pending order will be deleted by restart() function
                     restart(190);
                     return (0);               
                  }

                  else  //profit < 0
                  {
                     if(T == 9)  //highest order in series (order number 10) will have index = 9
                        {restart(10);  return (0);}
               
                     else
                     {
                        int cmd;
                  
                        chk = OrderSelect(tArray[T-1], SELECT_BY_TICKET);
                  
                        if(OrderType() == OP_BUY)
                           cmd = OP_BUYSTOP;
                        else
                           cmd = OP_SELLSTOP;
                     
                        tArray[T+1] = OrderSend(Symbol(), cmd, LotsArray[T+1], OrderOpenPrice(), slip, OrderStopLoss(), OrderTakeProfit(), NULL, Magic);
                        T++;
                        if(tArray[T] < 0)  {restart(0); return (0);}
                  
                        return (0);
                     }
                  }       
               }
            }
         }
      }  
   
      if(UseTrailOnly1 == true) TrailingStop1();
      if(UseZeroLossStrategy == true) ZeroLossStrategy();      
   
   }
   
   PrintComment();
   
   return(0);
}


void restart(int code)           //preparing everything for new series
{
   int i;
   
   switch(code)
   {
      case 1:     Alert("Could not open first BUYSTOP order. Error code: ", GetLastError(), " Restarting...");
                  break;
      case 2:     Alert("Could not open first SELLSTOP order. Error code: ", GetLastError(), " Restarting...");
                  break;
      case 0:     Alert("Could not open pending order number ", T, " in current series. Error code: ", GetLastError(), " Restarting...");
                  break;
      case 190:   Alert("Profit reached or out on trailing stop! Restarting...");
                  break;         
      case 200:   Alert("ZeroLossStrategy exit! Restarting...");
                  break; 
      case 10:    Alert("10 orders done. Series finished. Restarting...");
                  break;
      case -1:    Alert("Last order wasn\'t closed buy stoploss or takeprofit. Restarting...");
                  break;
      case -2:    Alert("Deinit. Deleting all pending orders.");
                  break;
      case -50:   Alert("Unsuccessfull LOAD. Restarting with default parameters.");
                  break;                                     
   }

   for(i=0; i<10; i++)           //deleting all pending orders
   {
      chk = OrderSelect(tArray[i], SELECT_BY_TICKET);
      if(OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP)
         chk = OrderDelete(tArray[i]);  
   }
   
   chk = OrderSelect(t1, SELECT_BY_TICKET);
   if(OrderType() == OP_BUYSTOP)
      chk = OrderDelete(t1);    
       
   chk = OrderSelect(t2, SELECT_BY_TICKET);
   if(OrderType() == OP_SELLSTOP)
      chk = OrderDelete(t2);           
   
   for(i=0; i<10; i++)           //preparing tArray[]
      tArray[i] = 0;

   T=0;
   t1=0;
   t2=0;
   
   
   BSP   = BuyStopPrice;         //needed restart flag
   flag  = 1;                    //main restart flag
   
   return ;   
}

void TrailingStop1()
{
   if(T==1) //.. 0- 
   {
      chk = OrderSelect(tArray[0], SELECT_BY_TICKET);
      
      if(OrderType() == OP_BUY)
         if(NormalizeDouble(Bid-OrderOpenPrice(),Digits)>NormalizeDouble(Point_*Trail1,Digits))   
            if(NormalizeDouble(Bid - OrderStopLoss(),Digits) > NormalizeDouble(Trail1*Point_,Digits))
               chk = OrderModify(OrderTicket(), 0, NormalizeDouble(Bid - Trail1*Point_,Digits), NormalizeDouble(OrderTakeProfit(),Digits), 0); 
   
      if(OrderType() == OP_SELL)
         if(NormalizeDouble(OrderOpenPrice()-Bid,Digits)>NormalizeDouble(Point_*Trail1,Digits))
            if(NormalizeDouble(OrderStopLoss() - Bid,Digits) > NormalizeDouble(Trail1*Point_,Digits))
               chk = OrderModify(OrderTicket(), 0, NormalizeDouble(Bid + Trail1*Point_,Digits), NormalizeDouble(OrderTakeProfit(),Digits), 0);        
   }
}

void ZeroLossStrategy()
{
   double summ_profit = 0.0;
   bool res = false;
   
   if(T>ZeroLossT) //..   #ZeroLossT  
   {
      for(int i=0; i<T; i++)
      {
         chk = OrderSelect(tArray[i], SELECT_BY_TICKET);
         summ_profit += OrderProfit();
      }
      
      if(summ_profit >= 0.0)
      {
         chk = OrderSelect(tArray[T-1], SELECT_BY_TICKET);  //  
         if(OrderType() == OP_BUY)
         {
            res = OrderClose(OrderTicket(), OrderLots(), Bid, slip, White);
         }
         else if(OrderType() == OP_SELL)
         {
            res = OrderClose(OrderTicket(), OrderLots(), Ask, slip, White);
         }
         
         if(res == true)
            restart(200);         
      }   
   }
}


int ExamineParameters()
{
//:   ,     ,         
//    , ..    ,  ,    . 
//( . . ,          )
   if(T==0)
   {
      chk = OrderSelect(t1, SELECT_BY_POS);
      if(OrderType() == OP_BUY)
         if(OrderCloseTime() != 0 || ( Bid - OrderStopLoss() < (MarketInfo(Symbol(), MODE_STOPLEVEL)+1)*Point_ ) )
            {Alert("1");      return(2); }
      chk = OrderSelect(t2, SELECT_BY_POS);
      if(OrderType() == OP_SELL)
         if(OrderCloseTime() != 0 || ( OrderStopLoss() - Ask < (MarketInfo(Symbol(), MODE_STOPLEVEL)+1)*Point_ ) )
            {Alert("2");      return(2); }
   }
   
   else
   {
      chk = OrderSelect(tArray[T], SELECT_BY_POS);
      if(OrderType() == OP_BUY)
         if(OrderCloseTime() != 0 || ( Bid - OrderStopLoss() < (MarketInfo(Symbol(), MODE_STOPLEVEL)+1)*Point_ ) )
            {Alert("4");      return(2); }
      if(OrderType() == OP_SELL)
         if(OrderCloseTime() != 0 || ( OrderStopLoss() - Ask < (MarketInfo(Symbol(), MODE_STOPLEVEL)+1)*Point_ ) )
            {Alert("5");      return(2); }
   }
   
   return(1);
}

//-----------------------------------------------  ------------------------------------------------
void SemaphoreTake(string SEM)
{ 
   if(GlobalVariableCheck(SEM) == false)
      GlobalVariableSet(SEM, 0);
  
   while(1==1)
   {
      if(GlobalVariableSetOnCondition(SEM, 1.0, 0.0))         // 
      {
         critical = 1;
         Print("SEMAPHORE \"", SEM, "\" TAKEN. CURRENT VALUE: ", GlobalVariableGet(SEM));
         break;      //    
      }
      else
      {
         Print("ATTEMPT TO CAPTURE SEMAPHORE \"", SEM, "\" FAILED. SEMAPHORE BUSY. WAITING 0.1 SEC. CURRENT VALUE: ", GlobalVariableGet(SEM));
         Sleep(100);
      }
   }
} 

void SemaphoreReturn(string SEM)
{
   GlobalVariableSet(SEM, 0.0);
   Print("SEMAPHORE \"", SEM, "\" RETURNED. CURRENT VALUE: ", GlobalVariableGet(SEM));
   critical = 0;
}



void CloseAllOrders()
{
   int res, i, total = OrdersTotal();
   
   Alert("!!! CLOSING ALL ORDERS !!!");
   Print("! Closing all orders performed by robot: Magic = ", Magic, " Symbol = ", Symbol());
   
   total = CreateTicketArrayAll(OP_BUY);   
   for(i=0; i<total; i++)
   {
      chk = OrderSelect(Ticket[i], SELECT_BY_TICKET);
      Print("Closing OP_BUY Order #", OrderTicket());
      SemaphoreTake("SEMAPHORE_CHEB_1");
      res = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(),MODE_BID), slip, White);         
      SemaphoreReturn("SEMAPHORE_CHEB_1");
      if(res < 0) Alert("OrderClose Error: ", GetLastError());
   }
   
   total = CreateTicketArrayAll(OP_SELL);   
   for(i=0; i<total; i++)
   {
      chk = OrderSelect(Ticket[i], SELECT_BY_TICKET);
      Print("Closing OP_SELL Order #", OrderTicket());
      SemaphoreTake("SEMAPHORE_CHEB_1");
      res = OrderClose(OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(),MODE_ASK), slip, White);         
      SemaphoreReturn("SEMAPHORE_CHEB_1");
      if(res < 0) Alert("OrderClose Error: ", GetLastError());
   }

   total = CreateTicketArrayAll(OP_BUYSTOP); 
   for(i=0; i<total; i++)
   {
      chk = OrderSelect(Ticket[i], SELECT_BY_TICKET);
      Print("Deleting OP_BUYSTOP Order #", OrderTicket());
      SemaphoreTake("SEMAPHORE_CHEB_1");
      res = OrderDelete(OrderTicket()); 
      SemaphoreReturn("SEMAPHORE_CHEB_1");
      if(res < 0) Alert("OrderDelete Error: ", GetLastError());   
   }

   total = CreateTicketArrayAll(OP_SELLSTOP);
   for(i=0; i<total; i++)
   {
      chk = OrderSelect(Ticket[i], SELECT_BY_TICKET);
      Print("Deleting OP_SELLSTOP Order #", OrderTicket());
      SemaphoreTake("SEMAPHORE_CHEB_1");
      res = OrderDelete(OrderTicket()); 
      SemaphoreReturn("SEMAPHORE_CHEB_1");
      if(res < 0) Alert("OrderDelete Error: ", GetLastError());   
   }

   total = CreateTicketArrayAll(OP_BUYLIMIT); 
   for(i=0; i<total; i++)
   {
      chk = OrderSelect(Ticket[i], SELECT_BY_TICKET);
      Print("Deleting OP_BUYLIMIT Order #", OrderTicket());
      SemaphoreTake("SEMAPHORE_CHEB_1");
      res = OrderDelete(OrderTicket()); 
      SemaphoreReturn("SEMAPHORE_CHEB_1");
      if(res < 0) Alert("OrderDelete Error: ", GetLastError());   
   }
   
   total = CreateTicketArrayAll(OP_SELLLIMIT); 
   for(i=0; i<total; i++)
   {
      chk = OrderSelect(Ticket[i], SELECT_BY_TICKET);
      Print("Deleting OP_SELLLIMIT Order #", OrderTicket());
      SemaphoreTake("SEMAPHORE_CHEB_1");
      res = OrderDelete(OrderTicket()); 
      SemaphoreReturn("SEMAPHORE_CHEB_1");
      if(res < 0) Alert("OrderDelete Error: ", GetLastError());   
   }      
}

int CreateTicketArrayAll(int dir)
{
   int total=OrdersTotal(), i, c=0; if (total<=0) return (0);
	for(i=0;i<total;i++) { chk = OrderSelect(i, SELECT_BY_POS); if (OrderType()==dir) { Ticket[c] = OrderTicket(); c++; } }
	return (c);
}

//-----------------------------------------------COMMENT------------------------------------------------
void PrintComment()
{
   Comment(CommentArray[0], "\n",
           "Current Situation: ", CommentArray[1], "\n",
           "-------------------------------\n",
           CommentArray[2], "\n",
           CommentArray[3], "\n",
           CommentArray[4], "\n",
           CommentArray[5], "\n",
           CommentArray[6], "\n");
}